// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new operations API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for operations API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetSbomDBResourceHash(params *GetSbomDBResourceHashParams, opts ...ClientOption) (*GetSbomDBResourceHashOK, error)

	PutSbomDBResourceHash(params *PutSbomDBResourceHashParams, opts ...ClientOption) (*PutSbomDBResourceHashCreated, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetSbomDBResourceHash gets an s b o m from d b by resource hash
*/
func (a *Client) GetSbomDBResourceHash(params *GetSbomDBResourceHashParams, opts ...ClientOption) (*GetSbomDBResourceHashOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetSbomDBResourceHashParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "GetSbomDBResourceHash",
		Method:             "GET",
		PathPattern:        "/sbomDB/{resourceHash}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetSbomDBResourceHashReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetSbomDBResourceHashOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*GetSbomDBResourceHashDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
  PutSbomDBResourceHash stores an s b o m in d b for the given resource hash
*/
func (a *Client) PutSbomDBResourceHash(params *PutSbomDBResourceHashParams, opts ...ClientOption) (*PutSbomDBResourceHashCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutSbomDBResourceHashParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "PutSbomDBResourceHash",
		Method:             "PUT",
		PathPattern:        "/sbomDB/{resourceHash}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutSbomDBResourceHashReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutSbomDBResourceHashCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PutSbomDBResourceHashDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
