// Copyright © 2022 Cisco Systems, Inc. and its affiliates.
// All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package vulnerability

import "strings"

const (
	DEFCON1    = "DEFCON1"
	CRITICAL   = "CRITICAL"
	HIGH       = "HIGH"
	MEDIUM     = "MEDIUM"
	LOW        = "LOW"
	NEGLIGIBLE = "NEGLIGIBLE"
)

// nolint:gomnd
func GetSeverityIntFromString(severity string) int {
	switch strings.ToUpper(severity) {
	case DEFCON1:
		return 5
	case CRITICAL:
		return 4
	case HIGH:
		return 3
	case MEDIUM:
		return 2
	case LOW:
		return 1
	case NEGLIGIBLE:
		return 0
	default:
		return 0
	}
}
